#include <stdint.h>

#include "items.h"

uint8_t item_properties(uint8_t item) {
	static const uint8_t properties[] = {
		// ________ animated sprite
		/// _______ initially hidden
		//|/ ______ explodes if crushed
		//||/ _____ breakable
		//|||/ ____ affected by gravity
		//||||/ ___ soapy
		//|||||/ __ player can goto
		//||||||/ _ pushable
		//|||||||/
		/*00010010*/0x12, // air
		/*00010010*/0x12, // dirt
		/*10011110*/0x9E, // diamond
		/*10011111*/0x9F, // boulder
		/*00010100*/0x14, // breakable wall
		/*11010100*/0xD4, // magic wall
		/*00000000*/0x00, // steel wall
		/*11000010*/0xC2, // exit
		/*10110010*/0xB2, // player
		/*10010000*/0x90, // amoeba
		/*10110000*/0xB0, // butterfly
		/*10110000*/0xB0, // firefly
	};
	return properties[item & ITEM_MASK];
}
