#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <tice.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "detect.h"
#include "menu.h"
#include "levelpack.h"

void print_text(int8_t xpos, int8_t ypos, const char *text) {
	os_SetCursorPos(ypos, xpos);
	os_PutStrLine(text);
}

void print_number(int8_t xpos, int8_t ypos, uint16_t value) {
	static char str[6];
	sprintf(str, "%u", value);
	print_text(xpos + 5 - strlen(str), ypos, str);
}

void main(void) {
	uint8_t choice;

	detect_levels();
	if (detected_levels_count > 0) {
		choice = menu();
		if ((uint8_t)(choice+1)) {
			levelpack_load(&detected_levels_name[choice][0]);
		}
		os_ClrHome();
	}
}
